	#!/usr/bin/perl 
	package line;
	use TeX::DVI::Parse;
	@ISA = qw( TeX::DVI::Parse);

	sub load_hyphen {
		my ($hyphenfile)=@_;
	use TeX::Hyphen;
	print STDERR "Loading hyphenation patterns from $hyphenfile\n";
	$hyphen=new TeX::Hyphen $hyphenfile;
	print STDERR "done...\n";
	}
	sub new {
		$class=shift;
		$self={};
		$self->{'v'}=shift;
		$self->{'colls'}=0;
		$self->{'leftmargin'}=20;
		$self->{'prev'}=0;
		$self->{'next'}=0;
		for ($i=0;$i<254;$i++) {$self->{'line'}[$i]=undef;}
		bless $self,$class;
		}
	sub addchar {
		$self=shift;
		my ($char,$h,$charwidth)=@_;
		$where=$h/$charwidth+20;
		while (defined $self->{'line'}[$where]) {
			$where++;
			$h+=$charwidth;
		}
		if ($self->{'leftmargin'}>$where) { $self->{'leftmargin'}=$where;}
		$self->{'line'}[$where]=$char;
		if ($self->{'colls'}<$where) { $self->{'colls'}=$where; }
		return $h;
		}


	sub printl {
	$odsaz=undef;
	$self=shift;
	my ($k)=@_;
	my @radek=undef;
	my $j=0;
	my $i=0;
	for (my $i=$self->{'leftmargin'};$i<=$self->{'colls'};$i++) {
		$znak=$self->{'line'}[$i];
		$radek[$j]=chr $znak if defined $znak;
		$radek[$j]=" " unless defined $znak;
		$radek[$j++]="f" if $znak==12;
		$radek[$j]="i" if $znak==12;
		$j++
	}
	$colls=$self->{'colls'};
	undef (my @radekupr);
	$j=0;
	$i=0;
	while (ord $radek[$i]==32 && $i<$colls) {
		$radekupr[$j++]=$radek[$i];
		$i++;
		}
		
	for (;$i<$colls;$i++) {
	$radekupr[$j++]=$radek[$i]; 
	if (ord $radek[$i]==32) { 
		$i++;
		while (ord $radek[$i]==32) {$i++};
		$i--;
		}
	}
	print @radekupr,"#\n";
	}

		
	sub hyphen {
	my ($k,$word)=@_;
	$lenw=length $word;
	$word=~s/ //g;
	$lenw-=length $word;
	undef (my @points);
	@points=$hyphen->hyphenate($word);
	my $i=0;
	while (defined $points[$i] && $k+$points[$i] < 30 ) { $i++;}
	if ($i==0) { print "\n",$word," "; return (length($word)+1); }
	else {
		$i--;
		@splitedword=split /\b|\B/, $word;
		for ($j=0;$j<length($word);$j++) {
		if ($j==$points[$i]) { print "-\n";}
		print $splitedword[$j]; 
		}
		print " ";
	return (length($word)-$points[$i]+1);
	}
	}

	sub printline {
	$odsaz=undef;
	$self=shift;
	my ($k)=@_;
	my @radek=undef;
	my $j=0;
	my $i=0;
	$colls=$self->{'colls'}+1;
	$left=$self->{'leftmargin'};

	for ($i=$left;$i<$colls;$i++) {
		$znak=$self->{'line'}[$i];
		$radek[$j]=chr $znak if defined $znak;
		$radek[$j]=" " unless defined $znak;
		$radek[$j]='-' if $znak==ord '{'; #Pomlcka
		$radek[$j++]="f" if $znak==12;
		$radek[$j]="i" if $znak==12;
		$j++
	}
	$colls=$j;
	$j=0;
	(my @radekupr);

	for (my $i=0;$i<$colls;$i++) { 	 #####Odstraneni prebytecnych mezer######
		$radekupr[$j++]=$radek[$i]; 
	if (ord $radek[$i]==32) { 
		$i++;
		while (ord $radek[$i]==32) {$i++};
		$i--;
		}
	}
	$colls=$i;
	############### ZJISTENI ZACATKU A KONCE TEXTU  NA RADKU ##################


	my $end=$colls;
	while (ord $radekupr[$end]==32 or ord $radekupr[$end] ==0  and $end > 0){ $end--; }
	$start=0;
	while (ord $radekupr[$start]==32 or ord $radekupr[$start] ==0  and $start < $colls)
	{ $start++; }
	$end++;
	#print STDERR "pokus -", $radekupr[$end-2],',',$radekupr[$end-1],',',$radekupr[$end],"#\n";
	if (ord $radekupr[$end-1]==ord '-' ) { $end--; }
#if (($end - $start) < 32) {
#print "\n";
#	print @radekupr,"\n";
#	$k=0;
#	return $k;
#}
############################## FORMATOVANI TEXTU ##############################
#$k=0;
@word=undef;
$i=$start;
		    #### ODDELENI JEDNOTLIVYCH SLOV ####

while ($i < $end) {	
$word=$word.$radekupr[$i];
if (ord $radekupr[$i++]==32 or $i==$end) { 
	if (($k+length($word))>30  ) {$k=hyphen($k,$word);$word=undef;}
	else
	{ 
	$k+=length($word); 
	print $word;
	$word=undef;
	}
}
}
if (ord $radekupr[$end]!=ord '-') {print " ";}
return ($k+1);
}

